diff --git a/tests/manager/test_all.py b/tests/manager/test_all.py
index 0f52a35..61fc0ad 100644
--- a/tests/manager/test_all.py
+++ b/tests/manager/test_all.py
@@ -2330,35 +937,28 @@ END:VCALENDAR"""
         'holidays': {'class': 'workalendar.europe.France', 'label': 'Holidays'},
     }
 )
-def test_meetings_agenda_time_period_exception_source_from_settings_toggle(app, admin_user):
+def test_meetings_agenda_add_desk_from_another(app, admin_user):
     agenda = Agenda.objects.create(label='Foo bar', kind='meetings')
     desk = Desk.objects.create(agenda=agenda, label='Desk A')
-    desk.import_timeperiod_exceptions_from_settings(enable=True)
-    desk2 = Desk.objects.create(agenda=agenda, label='Desk B')
-    desk2.import_timeperiod_exceptions_from_settings(enable=True)
-    assert desk.timeperiodexception_set.exists()
-    assert desk2.timeperiodexception_set.exists()
-
-    login(app)
-    resp = app.get('/manage/agendas/desk/%s/import-exceptions-from-ics/' % desk.pk)
-    assert 'Holidays' in resp.text
-    assert 'disabled' not in resp.text
-    assert 'refresh' not in resp.text
-
-    resp = resp.click('disable').follow()
-    assert not desk.timeperiodexception_set.exists()
-    assert desk2.timeperiodexception_set.exists()
-
-    resp = app.get('/manage/agendas/desk/%s/import-exceptions-from-ics/' % desk.pk)
-    assert 'Holidays' in resp.text
-    assert 'disabled' in resp.text
-
-    resp = resp.click('enable').follow()
-    assert desk.timeperiodexception_set.exists()
-    assert desk2.timeperiodexception_set.exists()
+    TimePeriod.objects.create(
+        weekday=1, desk=desk, start_time=datetime.time(10, 0), end_time=datetime.time(12, 0)
+    )
+    assert Desk.objects.count() == 1
+    assert desk.timeperiodexceptionsource_set.count() == 0
 
-    resp = app.get('/manage/agendas/desk/%s/import-exceptions-from-ics/' % desk.pk)
-    assert 'disabled' not in resp.text
+    app = login(app)
+    resp = app.get('/manage/agendas/%s/settings' % agenda.pk)
+    resp = resp.click('New Desk')
+    resp.form['label'] = 'Desk B'
+    resp.form['copy_from'] = desk.pk
+    resp = resp.form.submit().follow()
+    assert Desk.objects.count() == 2
+    new_desk = Desk.objects.latest('pk')
+    assert new_desk.label == 'Desk B'
+    assert new_desk.timeperiod_set.count() == 1
+    assert (
+        new_desk.timeperiodexceptionsource_set.count() == 0
+    )  # holidays not automatically added via duplication
 
 
 @override_settings(
@@ -2366,89 +966,106 @@ def test_meetings_agenda_time_period_exception_source_from_settings_toggle(app,
         'holidays': {'class': 'workalendar.europe.France', 'label': 'Holidays'},
     }
 )
-def test_meetings_agenda_time_period_exception_source_from_settings_toggle_desk_simple_management(
-    app, admin_user
-):
+def test_meetings_agenda_add_desk_simple_management(app, admin_user):
     agenda = Agenda.objects.create(label='Foo bar', kind='meetings', desk_simple_management=True)
     desk = Desk.objects.create(agenda=agenda, label='Desk A')
-    desk.import_timeperiod_exceptions_from_settings(enable=True)
-    source = desk.timeperiodexceptionsource_set.get()
-    desk2 = Desk.objects.create(agenda=agenda, label='Desk B')
-    desk2.import_timeperiod_exceptions_from_settings(enable=True)
-    source2 = desk2.timeperiodexceptionsource_set.get()
-    assert desk.timeperiodexception_set.exists()
-    assert desk2.timeperiodexception_set.exists()
-    assert agenda.is_available_for_simple_management() is True
-
-    login(app)
-
-    app.get('/manage/time-period-exceptions-source/%s/toggle' % source.pk)
-    source.refresh_from_db()
-    source2.refresh_from_db()
-    assert not source.enabled
-    assert not source2.enabled
-    assert not desk.timeperiodexception_set.exists()
-    assert not desk2.timeperiodexception_set.exists()
-    assert agenda.is_available_for_simple_management() is True
+    TimePeriod.objects.create(
+        weekday=1, desk=desk, start_time=datetime.time(10, 0), end_time=datetime.time(12, 0)
+    )
+    assert Desk.objects.count() == 1
+    assert desk.timeperiodexceptionsource_set.count() == 0
 
-    app.get('/manage/time-period-exceptions-source/%s/toggle' % source.pk)
-    source.refresh_from_db()
-    source2.refresh_from_db()
-    assert source.enabled
-    assert source2.enabled
-    assert desk.timeperiodexception_set.exists()
-    assert desk2.timeperiodexception_set.exists()
-    assert agenda.is_available_for_simple_management() is True
+    app = login(app)
+    resp = app.get('/manage/agendas/%s/add-desk' % agenda.pk)
+    resp.form['label'] = 'Desk B'
+    assert 'copy_from' not in resp.context['form'].fields
+    resp = resp.form.submit().follow()
+    assert Desk.objects.count() == 2
+    new_desk = Desk.objects.latest('pk')
+    assert new_desk.label == 'Desk B'
+    assert new_desk.timeperiod_set.count() == 1
+    assert (
+        new_desk.timeperiodexceptionsource_set.count() == 0
+    )  # holidays not automatically added via duplication
 
-    # should not happen: corresponding source does not exist
-    source2.delete()
-    app.get('/manage/time-period-exceptions-source/%s/toggle' % source.pk)
-    source.refresh_from_db()
-    assert not source.enabled
+    # ok if no desks (should not happen)
+    Desk.objects.all().delete()
+    resp = app.get('/manage/agendas/%s/add-desk' % agenda.pk)
+    resp.form['label'] = 'Desk'
+    assert 'copy_from' not in resp.context['form'].fields
+    resp = resp.form.submit().follow()
+    assert Desk.objects.count() == 1
+    new_desk = Desk.objects.latest('pk')
+    assert new_desk.timeperiodexceptionsource_set.count() == 1
 
 
-def test_meetings_agenda_time_period_exception_source_try_disable_ics(app, admin_user):
+def test_meetings_agenda_edit_desk(app, admin_user):
     agenda = Agenda.objects.create(label='Foo bar', kind='meetings')
     desk = Desk.objects.create(agenda=agenda, label='Desk A')
-    MeetingType(agenda=agenda, label='Blah').save()
-    TimePeriod.objects.create(
-        weekday=1, desk=desk, start_time=datetime.time(10, 0), end_time=datetime.time(12, 0)
-    )
-    source = TimePeriodExceptionSource.objects.create(desk=desk, ics_url='https://example.com/test.ics')
+    desk2 = Desk.objects.create(agenda=agenda, label='Desk B')
+    other_agenda = Agenda.objects.create(label='Foo bar', kind='meetings')
+    other_desk = Desk.objects.create(agenda=other_agenda, label='Desk A')
+    assert other_desk.slug == desk.slug
 
-    login(app)
-    resp = app.get('/manage/agendas/%d/' % agenda.pk).follow().follow()
-    resp = resp.click('Settings')
-    resp = resp.click('manage exceptions')
-    assert 'test.ics' in resp.text
+    app = login(app)
+    resp = app.get('/manage/desks/%s/edit' % desk.pk)
+    resp.form['label'] = 'Desk C'
+    resp.form['slug'] = desk.slug
+    resp = resp.form.submit().follow()
+    assert 'Desk A' not in resp.text
+    assert 'Desk B' in resp.text
+    assert 'Desk C' in resp.text
+    desk.refresh_from_db()
+    assert desk.label == 'Desk C'
+    assert desk.slug == other_desk.slug
 
-    assert app.get('/manage/time-period-exceptions-source/%s/toggle' % source.pk, status=404)
+    # check slug edition
+    resp = app.get('/manage/desks/%s/edit' % desk.pk)
+    resp.form['slug'] = desk2.slug
+    resp = resp.form.submit()
+    assert resp.context['form'].errors['slug'] == ['Another desk exists with the same identifier.']
 
+    # unknown pk
+    app.get('/manage/desks/0/edit', status=404)
 
-@override_settings(
-    EXCEPTIONS_SOURCES={
-        'holidays': {'class': 'workalendar.europe.France', 'label': 'Holidays'},
-    }
-)
-def test_meetings_agenda_time_period_exception_source_from_settings(app, admin_user, freezer):
-    freezer.move_to('2020-01-01')
+    # wrong kind
+    agenda.kind = 'virtual'
+    agenda.save()
+    app.get('/manage/desks/%s/edit' % desk.pk, status=404)
+    agenda.kind = 'events'
+    agenda.save()
+    app.get('/manage/desks/%s/edit' % desk.pk, status=404)
+
+
+def test_meetings_agenda_delete_desk(app, admin_user):
     agenda = Agenda.objects.create(label='Foo bar', kind='meetings')
-    desk = Desk.objects.create(agenda=agenda, label='Desk A')
-    desk.import_timeperiod_exceptions_from_settings(enable=True)
-    new_year = desk.timeperiodexception_set.filter(label='New year').first()
-    remove_url = reverse('chrono-manager-time-period-exception-delete', kwargs={'pk': new_year.pk})
-    edit_url = reverse('chrono-manager-time-period-exception-edit', kwargs={'pk': new_year.pk})
+    Desk.objects.create(agenda=agenda, label='Desk A')
+    desk_b = Desk.objects.create(agenda=agenda, label='Desk B')
 
-    login(app)
-    resp = app.get('/manage/agendas/%d/settings' % agenda.pk)
-    assert 'New year' in resp.text
-    assert remove_url not in resp.text and edit_url not in resp.text
+    app = login(app)
+
+    resp = app.get('/manage/agendas/%s/settings' % agenda.pk)
+    resp = resp.click('Desk A')
+    resp = resp.click('Delete')
+    resp = resp.form.submit()
+    assert resp.location.endswith('/manage/agendas/%s/settings' % agenda.pk)
+    assert Desk.objects.count() == 1
+
+    # only one desk
+    app.get('/manage/desks/%s/delete' % desk_b.pk, status=404)
 
-    resp = resp.click('see all')
-    assert 'New year' in resp.text
-    assert remove_url not in resp.text and edit_url not in resp.text
+    desk_a = Desk.objects.create(agenda=agenda, label='Desk A')
+
+    # unknown pk
+    app.get('/manage/desks/0/delete', status=404)
 
-    app.get(remove_url, status=404)
+    # wrong kind
+    agenda.kind = 'virtual'
+    agenda.save()
+    app.get('/manage/desks/%s/delete' % desk_a.pk, status=404)
+    agenda.kind = 'events'
+    agenda.save()
+    app.get('/manage/desks/%s/delete' % desk_a.pk, status=404)
 
 
 def test_agenda_day_view(app, admin_user, manager_user, api_user):
@@ -4455,117 +3072,3 @@ def test_agenda_booking_colors(app, admin_user, api_user, view):
     assert resp.text.count('Swimming') == 2  # 1 booking + legend
     assert 'Booking colors:' in resp.text
     assert len(resp.pyquery.find('div.booking-colors span.booking-color-label')) == 2
-
-
-@override_settings(
-    EXCEPTIONS_SOURCES={
-        'holidays': {'class': 'workalendar.europe.France', 'label': 'Holidays'},
-    }
-)
-def test_recurring_events_manage_exceptions(settings, app, admin_user, freezer):
-    freezer.move_to('2021-07-01 12:10')
-
-    app = login(app)
-    resp = app.get('/manage/')
-    resp = resp.click('New')
-    resp.form['label'] = 'Foo bar'
-    resp.form['kind'] = 'events'
-    resp = resp.form.submit().follow()
-
-    agenda = Agenda.objects.get(label='Foo bar')
-    assert agenda.desk_set.count() == 1
-    desk = agenda.desk_set.get(slug='_exceptions_holder')
-
-    event = Event.objects.create(start_datetime=now(), places=10, agenda=agenda)
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    assert not 'Recurrence exceptions' in resp.text
-
-    event.recurrence_days = list(range(7))
-    event.save()
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.id, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 31
-
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    assert 'Recurrence exceptions' in resp.text
-
-    resp = resp.click('Add a time period exception')
-    resp.form['start_datetime_0'] = now().strftime('%Y-%m-%d')
-    resp.form['start_datetime_1'] = now().strftime('%H:%M')
-    resp.form['end_datetime_0'] = (now() + datetime.timedelta(days=7)).strftime('%Y-%m-%d')
-    resp.form['end_datetime_1'] = (now() + datetime.timedelta(days=7)).strftime('%H:%M')
-    resp = resp.form.submit().follow()
-    assert desk.timeperiodexception_set.count() == 1
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.id, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 24
-
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    resp = resp.click('Configure', href='exceptions')
-    resp = resp.click('enable').follow()
-    assert TimePeriodException.objects.count() > 1
-    assert 'Bastille Day' in resp.text
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.id, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 23
-
-    # add recurrence end date, which lead to recurrences creation
-    resp = app.get('/manage/agendas/%s/events/%s/edit' % (agenda.id, event.id))
-    resp.form['recurrence_end_date'] = (now() + datetime.timedelta(days=31)).strftime('%Y-%m-%d')
-    resp = resp.form.submit()
-
-    # recurrences corresponding to exceptions have not been created
-    assert Event.objects.count() == 24
-
-
-def test_recurring_events_exceptions_report(settings, app, admin_user, freezer):
-    freezer.move_to('2021-07-01 12:10')
-    agenda = Agenda.objects.create(label='Foo bar', kind='events')
-    Desk.objects.create(agenda=agenda, slug='_exceptions_holder')
-    event = Event.objects.create(
-        start_datetime=now(),
-        places=10,
-        recurrence_days=list(range(7)),
-        recurrence_end_date=now() + datetime.timedelta(days=30),
-        agenda=agenda,
-    )
-    event.create_all_recurrences()
-
-    app = login(app)
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.pk, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 30
-
-    time_period_exception = TimePeriodException.objects.create(
-        desk=agenda.desk_set.get(),
-        start_datetime=datetime.date(year=2021, month=7, day=5),
-        end_datetime=datetime.date(year=2021, month=7, day=10),
-    )
-    call_command('update_event_recurrences')
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.pk, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 25
-
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    assert not 'warningnotice' in resp.text
-
-    event = Event.objects.get(start_datetime__day=11)
-    booking = Booking.objects.create(event=event)
-    time_period_exception.end_datetime = datetime.date(year=2021, month=7, day=12)
-    time_period_exception.save()
-    call_command('update_event_recurrences')
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.pk, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 24
-
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    assert 'warningnotice' in resp.text
-    assert 'July 11, 2021, 2:10 p.m.' in resp.text
-
-    booking.cancel()
-    call_command('update_event_recurrences')
-
-    resp = app.get('/manage/agendas/%s/%s/%s/' % (agenda.pk, 2021, 7))
-    assert len(resp.pyquery.find('.event-info')) == 23
-
-    resp = app.get('/manage/agendas/%s/settings' % agenda.id)
-    assert not 'warningnotice' in resp.text
